package kz.arta.demo.utils;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

/**
 * User: Mikhail Milyutin
 * Date: 25.05.17.
 * Time: 14:41.
 */
public class UserSearchService {
    private static final Logger LOGGER = LoggerFactory.getLogger(UserSearchService.class);

    public static String getUserByNumber(String number) {
        HttpURLConnection connection = null;
        try {

            //логика для поиска пользователя, здесь - по полю в карточке пользователя в itsm
            URL url = new URL("http://test-kzpitsm.arta.pro/Synergy/rest/api/filecabinet/get_by_field_value?formCode=" + PropCodes.itsm_card_userCard + "&fieldName=" + PropCodes.user_card_initial_number_field + "&value=" + number);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("GET");
            conn.setRequestProperty("Accept", "application/json; charset=utf-8");

            conn.setRequestProperty("Authorization", PropsUtil.getAuthEncoded());

            String output;
            StringBuilder result = new StringBuilder();

            BufferedReader br = new BufferedReader(new InputStreamReader((conn.getInputStream())));

            while ((output = br.readLine()) != null) {
                result.append(output);
            }

            conn.disconnect();

            LOGGER.info("[API.RESP] " + result.toString());

            if (!result.toString().isEmpty()) {
                return result.toString();
            }
        } catch (IOException e) {
            LOGGER.error(e.getMessage(), e);
        } finally {
            if (connection != null) {
                connection.disconnect();
            }
        }
        return null;
    }

}
